/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahl.boundary;

import de.ivu.elect.business.wahl.entity.Wahltermin;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class WahlterminDAO extends AbstractWahlterminDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Wahltermin wahltermin){
    getEntityManager().persist(wahltermin);
  }

  public void remove(Wahltermin wahltermin){
    getEntityManager().remove(wahltermin);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: AllNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Wahltermin o WHERE o.mandant=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahltermin> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahltermin.findByAll" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByAll( mandant  ));
        }
        return (java.util.List<Wahltermin>) cached;
        }
            return super.findByAll( mandant  );
            }
                                            
        /**
        * Name: AllSystemweitNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Wahltermin o<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahltermin> findByAllSystemweit() {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahltermin.findByAllSystemweit"  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByAllSystemweit( ));
        }
        return (java.util.List<Wahltermin>) cached;
        }
            return super.findByAllSystemweit( );
            }
                                                
        /**
        * Name: NameNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.name = ?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahltermin> findByName( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String name) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahltermin.findByName" ,  mandant ,  name  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByName( mandant ,  name  ));
        }
        return (java.util.List<Wahltermin>) cached;
        }
            return super.findByName( mandant ,  name  );
            }
                                        
        /**
        * Name: StatusNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.status = ?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahltermin> findByStatus( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.WahlterminStatus status) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahltermin.findByStatus" ,  mandant ,  status  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByStatus( mandant ,  status  ));
        }
        return (java.util.List<Wahltermin>) cached;
        }
            return super.findByStatus( mandant ,  status  );
            }
                                                                        
        /**
        * Name: WahldatumDeprecatedNoFlush<br>
        * Beschreibung: @Deprecated // mit Nummer verwenden<br>
        * EJBQL: SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.wahldatum = ?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Wahltermin> findByWahldatumDeprecated( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull java.util.Date wahldatum) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Wahltermin.findByWahldatumDeprecated" ,  mandant ,  wahldatum  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahldatumDeprecated( mandant ,  wahldatum  ));
        }
        return (java.util.List<Wahltermin>) cached;
        }
            return super.findByWahldatumDeprecated( mandant ,  wahldatum  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}